---
title: Firefox 32 for developers
slug: Mozilla/Firefox/Releases/32
tags:
  - Firefox
---
<div>{{FirefoxSidebar}}</div><h2 id="Changes_for_Web_developers">Changes for Web developers</h2>

<h3 id="Developer_Tools">Developer Tools</h3>

<p>Highlights:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Web_Audio_Editor">Web Audio Editor</a></li>
 <li><a href="/en-US/docs/Tools/Scratchpad#Code_completion_and_inline_documentation">Code completion and inline documentation in Scratchpad</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector#Rules_view">User agent styles in the Inspector's Rules view</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector#Firefox_32_onwards_2">Element picker button has moved</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector#Firefox_32_onwards">Node dimensions added to the Inspector's infobar</a></li>
 <li><a href="/en-US/docs/Tools/Tools_Toolbox#Extra_tools">Full page screenshot button added</a></li>
 <li>HiDPI images added to the tools</li>
 <li>Nodes that have <code>display:none</code> are shown differently in the Inspector</li>
</ul>

<p><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;classification=Client%20Software&amp;chfieldto=2014-06-09&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2014-04-28&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;component=Developer%20Tools&amp;component=Developer%20Tools%3A%203D%20View&amp;component=Developer%20Tools%3A%20App%20Manager&amp;component=Developer%20Tools%3A%20Canvas%20Debugger&amp;component=Developer%20Tools%3A%20Console&amp;component=Developer%20Tools%3A%20Debugger&amp;component=Developer%20Tools%3A%20Framework&amp;component=Developer%20Tools%3A%20Graphic%20Commandline%20and%20Toolbar&amp;component=Developer%20Tools%3A%20Inspector&amp;component=Developer%20Tools%3A%20Memory&amp;component=Developer%20Tools%3A%20Netmonitor&amp;component=Developer%20Tools%3A%20Object%20Inspector&amp;component=Developer%20Tools%3A%20Profiler&amp;component=Developer%20Tools%3A%20Responsive%20Mode&amp;component=Developer%20Tools%3A%20Scratchpad&amp;component=Developer%20Tools%3A%20Source%20Editor&amp;component=Developer%20Tools%3A%20Style%20Editor&amp;component=Developer%20Tools%3A%20User%20Stories&amp;component=Developer%20Tools%3A%20WebGL%20Shader%20Editor&amp;product=Firefox">All devtools bugs fixed between Firefox 31 and Firefox 32</a>.</p>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Enabled {{cssxref("mix-blend-mode")}} by default ({{Bug(952643)}}).</li>
 <li>Enabled <code>position:sticky</code> by default in release builds (only enabled on Nightly and Aurora before) ({{Bug(916315)}}).</li>
 <li>Implemented {{cssxref("box-decoration-break")}} and removed the non-standard {{cssxref("-moz-background-inline-policy")}}({{Bug(613659)}}).</li>
 <li>Allowed {{cssxref("flex-grow")}} and  {{cssxref("flex-shrink")}} to transition between zero and nonzero values, like 'flex-grow: 0.6'({{Bug(996945)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Experimentally implemented, behind a pref, {{HTMLElement("img")}} {{HTMLattrxref("srcset", "img")}} property, To activate it  set <code>dom.image.srcset.enable</code> to <code>true</code> ({{Bug(870021)}}).</li>
 <li><a href="/en-US/docs/Web/HTML/Global_attributes/id"><strong>id</strong></a> and <a href="/en-US/docs/Web/HTML/Global_attributes/class"><strong>class</strong></a> are now true <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a> and also apply to XML elements, in a namespace or not ({{bug(741295)}}).</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The following new ECMAScript 2015 built-in methods got implemented:
  <ul>
   <li>{{jsxref("Array.from()")}} ({{bug(904723)}}),</li>
   <li>{{jsxref("Array.prototype.copyWithin()")}} ({{bug(934423)}}),</li>
   <li>{{jsxref("Number.isSafeInteger()")}} ({{bug(1003764)}}).</li>
  </ul>
 </li>
</ul>

<h3 id="InterfacesAPIsDOM">Interfaces/APIs/DOM</h3>

<ul>
 <li>The {{domxref("NavigatorLanguage.languages", "navigator.languages")}} property and {{event("languagechange")}} event have been implemented ({{Bug(889335)}}).</li>
 <li>The {{domxref("Navigator.vibrate()")}} method behavior has been adapted to the latest specification: too long vibrations are now truncated ({{bug(1014581)}}).</li>
 <li>The {{domxref("KeyboardEvent.getModifierState()")}} and {{domxref("MouseEvent.getModifierState()")}} methods have been extended to support the <code>Accel</code> virtual modifier ({{Bug(1009388)}}).</li>
 <li>The {{domxref("KeyboardEvent.code")}} property have been experimentally implemented: it is disabled on release build ({{Bug(865649)}}).</li>
 <li>Scoped selectors for {{domxref("Document.querySelector()")}} and  {{domxref("Document.querySelectorAll()")}}, for example <code>querySelector(":scope &gt; li")</code>have been implemented ({{Bug(528456)}}).</li>
 <li>The experimental implementation of the  {{domxref("Document.timeline")}} interface, related to the <a href="http://dev.w3.org/fxtf/web-animations/">Web Animation API</a>, has been added ({{bug("998246")}}). It is controlled by <code>layout.web-animations.api.enabled</code> preference, enabled only on Nightly and Aurora for the moment.</li>
 <li>The <a href="/en-US/docs/Web/API/Data_Store_API">Data Store API</a> has been made available to <a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Web Workers</a> ({{bug("949325")}}). It still is only activated for certified applications.</li>
 <li>The <a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker</a> {{domxref("InstallPhaseEvent")}} and {{domxref("InstallEvent")}} interfaces have been implemented ({{ Bug("967264") }}).</li>
 <li> The <a href="/en-US/docs/Web/API/MSISDN_Verification_API">MSISDN Verification API</a>, only activated for privileged apps, has been added ({{ Bug("988469") }}).</li>
 <li>The <a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a> is now supported on Firefox for Android ({{bug(852935)}}).</li>
 <li>To match the spec and the evolution of the CSS syntax, minor changes have been done to {{domxref("CSS.escape()")}}. The identifier now can begins with <code>'--'</code> and the second dash must not be escaped. Also vendor identifier are no more escaped. ({{bug(1008719)}})</li>
 <li>To complete our Hit Regions implementation, {{domxref("MouseEvent.region")}} has been implemented ({{bug(979692)}}).</li>
 <li>The {{domxref("CanvasRenderingContext2D.drawFocusIfNeeded()")}} method is now enabled by default ({{bug(1004579)}}).</li>
 <li>The {{domxref("Navigator.doNotTrack")}} properties now returns <code>'1'</code> or <code>'0'</code>, reflecting the HTTP value, instead of  <code>'yes'</code> or <code>'no'</code> ({{bug(887703)}}).</li>
 <li><a href="/en-US/docs/Web/API/XMLHttpRequest/responseURL">XMLHttpRequest.responseURL</a> was implemented ({{bug(998076)}})..</li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li>Add support for the {{MathMLElement("menclose")}} notation <code>phasorangle</code>.</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No change.</em></p>

<h3 id="WebRTC">WebRTC</h3>

<ul>
 <li>New constraints for <a href="/en-US/docs/Glossary/WebRTC">WebRTC</a>'s {{domxref("NavigatorUserMedia.getUserMedia", "getUserMedia()")}}, <code>width</code>, <code>height</code>, and <code>framerate</code>,  have been added, to limit stream dimensions and frame rate ({{bug("907352")}}):

  <pre class="brush: json">{
  mandatory: {
    width: { min: 640 },
    height: { min: 480 }
  },
  optional: [
    { width: 650 },
    { width: { min: 650 }},
    { frameRate: 60 },
    { width: { max: 800 }},
  ]
}</pre>
 </li>
 <li>WebRTC methods which previously used callback functions as input parameters are now also available using JavaScript <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">promises</a>.</li>
</ul>

<h3 id="AudioVideo">Audio/Video</h3>

<p><em>No change.</em></p>

<h2 id="Security">Security</h2>

<ul>
 <li><a href="/en-US/docs/Xray_vision#Xray_semantics_for_Object_and_Array">Privileged code now gets Xray vision for JavaScript <code>Object</code> and <code>Array</code> instances</a>.</li>
</ul>

<h2 id="Changes_for_add-on_and_Mozilla_developers">Changes for add-on and Mozilla developers</h2>

<p>Xray vision is now applied to JavaScript objects that are not themselves DOM objects: <a href="/en-US/docs/Xray_vision#Xrays_for_JavaScript_objects">Xrays for JavaScript objects</a>.</p>

<p>A <code><a href="/en-US/Add-ons/Add-on_Manager/Addon#getDataDirectory()">getDataDirectory()</a></code> method has been added to <code><a href="/en-US/Add-ons/Add-on_Manager/Addon">Addon</a></code> instances. This method returns the preferred location, within the current profile, for add-ons to store data.</p>

<h3 id="Add-on_SDK">Add-on SDK</h3>

<h4 id="Highlights">Highlights</h4>

<ul>
 <li>Added <a href="https://developer.mozilla.org/en-US/Add-ons/SDK/High-Level_APIs/page-mod#PageMod%28options%29"><code>exclude</code></a> option to <code>PageMod</code>.</li>
 <li>Added <a href="https://developer.mozilla.org/en-US/Add-ons/SDK/High-Level_APIs/request#Request%28options%29"><code>anonymous</code></a> option to <code>Request</code>.</li>
 <li><a href="https://developer.mozilla.org/en-US/Add-ons/Add-on_Debugger">Add-on Debugger</a> now includes a Console and a Scratchpad.</li>
</ul>

<h4 id="Details">Details</h4>

<p><a class="external external-icon" href="https://github.com/mozilla/addon-sdk/compare/firefox31...firefox32">GitHub commits made between Firefox 31 and Firefox 32</a>. This will not include any uplifts made after this release entered Aurora.</p>

<p><a class="external external-icon" href="https://bugzilla.mozilla.org/buglist.cgi?resolution=FIXED&amp;chfieldto=2014-06-09&amp;chfield=resolution&amp;query_format=advanced&amp;chfieldfrom=2014-04-28&amp;chfieldvalue=FIXED&amp;bug_status=RESOLVED&amp;bug_status=VERIFIED&amp;bug_status=CLOSED&amp;product=Add-on%20SDK&amp;list_id=10493962">Bugs fixed between Firefox 31 and Firefox 32</a>. This will not include any uplifts made after this release entered Aurora.</p>

<h3 id="XPCOM">XPCOM</h3>

<ul>
 <li>The {{interface("nsIUDPSocket")}} interface now provides multicast support through the addition of the new {{ifattribute("nsIUDPSocket", "multicastLoopback")}}, {{ifattribute("nsIUDPSocket", "multicastInterface")}}, and {{ifattribute("nsIUDPSocket", "multicastInterfaceAddr")}} attributes, as well as the {{ifmethod("nsIUDPSocket", "joinMulticast")}} and {{ifmethod("nsIUDPSocket", "leaveMulticast")}} methods.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://www.fxsitecompat.com/en-US/versions/32/">Site Compatibility for Firefox 32</a></li>
</ul>

<h3 id="Older_versions">Older versions</h3>

<p>{{Firefox_for_developers('31')}}</p>
